Name:           jhdf5
Version:        2.11.0
Release:        7%{?dist}
Summary:        Java HDF5 Package
License:        BSD with advertising
URL:            http://www.hdfgroup.org/products/java/
Source0:        http://www.hdfgroup.org/ftp/HDF5/hdf-java/current/src/hdf-java-%{version}.tar.gz
Source1:        hdfview
Source2:        hdfview.xml
Source3:        hdfview.desktop

Patch1:         jhdf5-0001-add-a-generic-linux-host.patch
Patch2:         jhdf5-0002-add-H4_-prefix-to-constants.patch
Patch3:         jhdf5-0003-use-system-linker-for-shared-library.patch
Patch4:         jhdf5-0004-remove-writable-prefix-check.patch
Patch5:         jhdf5-0005-update-config.sub-and-config.guess.patch
Patch6:         jhdf5-0006-update-configure.patch

BuildRequires:  hdf-static
BuildRequires:  hdf5-devel
BuildRequires:  java-devel
BuildRequires:  javapackages-local
BuildRequires:  libjpeg-devel
BuildRequires:  slf4j

BuildRequires:  junit
BuildRequires:  ImageMagick
BuildRequires:  desktop-file-utils

Requires:       java-headless
Requires:       javapackages-tools
Requires:       slf4j
# hdf5 does not bump soname but check at runtime
Requires:       hdf5 = %{_hdf5_version}

%description
HDF is a versatile data model that can represent very complex data objects
and a wide variety of meta-data. It is a completely portable file format
with no limit on the number or size of data objects in the collection.

This Java package wrap the native HDF5 library.

%package devel
Summary:        JHDF5 development files
Requires:       %{name} = %{version}-%{release}
Requires:       hdf5-devel

%description devel
JHDF5 development headers and libraries.

%package -n jhdf
Summary:        Java HDF Package
Requires:       java-headless
Requires:       javapackages-tools
Requires:       slf4j

%description -n jhdf
HDF is a versatile data model that can represent very complex data objects
and a wide variety of meta-data. It is a completely portable file format
with no limit on the number or size of data objects in the collection.

This Java package wrap the native HDF4 library.

%package -n jhdfobj
Summary:        Java HDF/HDF5 Object Package
Requires:       java-headless
Requires:       javapackages-tools
Requires:       slf4j
Requires:       hdf
# hdf5 does not bump soname but check at runtime
Requires:       hdf5 = %{_hdf5_version}
Requires:       jhdf = %{version}-%{release}
Requires:       jhdf5 = %{version}-%{release}

BuildArch:      noarch

%description -n jhdfobj
HDF is a versatile data model that can represent very complex data objects
and a wide variety of meta-data. It is a completely portable file format
with no limit on the number or size of data objects in the collection.

This Java package implements HDF4/HDF5 data objects in an 
object-oriented form. It provides a common Java API for accessing HDF files.

%package -n hdfview
Summary:        Java HDF Object viewer
Requires:       java
Requires:       javapackages-tools
Requires:       jhdfobj = %{version}-%{release}
Requires:       slf4j

Requires(post): desktop-file-utils
Requires(postun): desktop-file-utils

BuildArch:      noarch

%description -n hdfview
HDF is a versatile data model that can represent very complex data objects
and a wide variety of meta-data. It is a completely portable file format
with no limit on the number or size of data objects in the collection.

This package provides a HDF4/HDF5 viewer.

%package javadoc
Summary:       Javadoc for %{name}

%description javadoc
This package contains javadoc for %{name}.

%prep
%setup -q -n hdf-java-%{version}
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1

# remove shipped jars
find -name '*.jar' -print -delete
rm -r docs/javadocs

# build jar repo
build-jar-repository -p lib/ junit slf4j-
ln -s slf4j-api.jar lib/slf4j-api-1.7.5.jar
ln -s slf4j-nop.jar lib/slf4j-nop-1.7.5.jar

# fix spurious-executable-perm
chmod -x $(find docs -type f)
chmod -x $(find native -type f)
chmod -x COPYING

# Prevent javadoc build failure
sed -i 's/$(JAVADOC_FLAGS)/$(JAVADOC_FLAGS) -Xdoclint:none/' Makefile*

# artifacts location
%mvn_package org.hdfgroup:jhdf5 jhdf5
%mvn_file org.hdfgroup:jhdf5 jhdf5
%mvn_package org.hdfgroup:jhdf jhdf
%mvn_file org.hdfgroup:jhdf jhdf
%mvn_package org.hdfgroup:jhdfobj jhdfobj
%mvn_file org.hdfgroup:jhdfobj jhdfobj
%mvn_package org.hdfgroup:jhdf4obj jhdfobj
%mvn_file org.hdfgroup:jhdf4obj jhdf4obj
%mvn_package org.hdfgroup:jhdf5obj jhdfobj
%mvn_file org.hdfgroup:jhdf5obj jhdf5obj
%mvn_package org.hdfgroup:jhdfview jhdfview
%mvn_file org.hdfgroup:jhdfview jhdfview

%build
%configure --with-jdk=%{java_home}/include,%{java_home}/lib \
        --with-hdf5=%{_includedir},%{_libdir} \
        --with-hdf4=%{_includedir}/hdf,%{_libdir}/hdf \
        --without-h4toh5 \
        --without-libsz \
        --with-libz=%{_includedir},%{_libdir} \
        --with-libjpeg=%{_includedir},%{_libdir}

# Make JNI (libjhdf.so libjhdf5.so) and
# make only required jars (not netcdf nor fits related packages)
make -C ncsa

make natives jhdf-packages jhdf5-packages \
     jhdfobj-packages jhdfview-packages javadocs

%check
make tests

%install

# jars and depmap
%mvn_artifact org.hdfgroup:jhdf5:%{version} lib/jhdf5.jar
%mvn_artifact org.hdfgroup:jhdf:%{version} lib/jhdf.jar
%mvn_artifact org.hdfgroup:jhdfobj:%{version} lib/jhdfobj.jar
%mvn_artifact org.hdfgroup:jhdf4obj:%{version} lib/jhdf4obj.jar
%mvn_artifact org.hdfgroup:jhdf5obj:%{version} lib/jhdf5obj.jar
%mvn_artifact org.hdfgroup:jhdfview:%{version} lib/jhdfview.jar
%mvn_install -J docs/javadocs

rm -r docs/javadocs

install -Dm 744 lib/linux/libjhdf5.so %{buildroot}%{_libdir}/jhdf5/libjhdf5.so
install -Dm 744 lib/linux/libjhdf.so %{buildroot}%{_libdir}/jhdf/libjhdf.so

install -Dpm 755 %{SOURCE1} %{buildroot}%{_bindir}/hdfview

# Create and install hicolor icons.
for i in 16 22 32 48 ; do
  mkdir -p icons/${i}x${i}/apps
  convert -resize ${i}x${i} ncsa/hdf/view/icons/hdf_large.gif \
    icons/${i}x${i}/apps/hdfview.png

  install -Dpm 0644 icons/${i}x${i}/apps/hdfview.png \
    %{buildroot}%{_datadir}/icons/hicolor/${i}x${i}/apps/hdfview.png

  install -Dpm 0644 icons/${i}x${i}/apps/hdfview.png \
    %{buildroot}%{_datadir}/icons/hicolor/${i}x${i}/mimetypes/application-x-hdf.png

done

# .desktop file
mkdir -p %{buildroot}%{_datadir}/applications
desktop-file-install                                    \
        --dir %{buildroot}%{_datadir}/applications      \
        %{SOURCE3}

# mime types
install -Dpm 644 %{SOURCE2} \
        %{buildroot}%{_datadir}/mime/packages/hdfview.xml

%post -n hdfview
update-desktop-database &> /dev/null || :
touch --no-create %{_datadir}/icons/hicolor &>/dev/null || :
touch --no-create %{_datadir}/mime/packages &>/dev/null || :

%postun -n hdfview
update-desktop-database &> /dev/null || :
if [ $1 -eq 0 ] ; then
    touch --no-create %{_datadir}/icons/hicolor &>/dev/null || :
    gtk-update-icon-cache %{_datadir}/icons/hicolor &>/dev/null || :
    update-mime-database %{_datadir}/mime &> /dev/null || :
fi

%posttrans -n hdfview
gtk-update-icon-cache %{_datadir}/icons/hicolor &>/dev/null || :
update-mime-database %{?fedora:-n} %{_datadir}/mime &> /dev/null || :

%global _docdir_fmt %{name}

%files -f .mfiles-jhdf5
%attr(755,root,root) %{_libdir}/jhdf5/libjhdf5.so
%doc Readme.txt
%license COPYING

%files -n jhdf -f .mfiles-jhdf
%attr(755,root,root) %{_libdir}/jhdf/libjhdf.so
%license COPYING

%files -n jhdfobj -f .mfiles-jhdfobj
%license COPYING

%files -n hdfview -f .mfiles-jhdfview
%{_bindir}/hdfview
%{_datadir}/applications/hdfview.desktop
%{_datadir}/icons/hicolor/*/*/*
%{_datadir}/mime/packages/hdfview.xml
%doc docs 
%license COPYING

%files javadoc -f .mfiles-javadoc
%license COPYING

%changelog
* Mon Mar 28 2016 gil cattaneo <puntogil@libero.it> 2.11.0-7
- generate maven depmap and javadoc
- add javadoc sub package
- minor changes to adapt to current guideline
- fix some rpmlint problems
- introduce license macro

* Sat Dec 12 2015 Orion Poplawski <orion@cora.nwra.com> - 2.11.0-4
- BR hdf-static

* Wed Jun 17 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.11.0-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Sun May 17 2015 Orion Poplawski <orion@cora.nwra.com> - 2.11.0-2
- Rebuild for hdf5 1.8.15

* Wed Jan 7 2015 Orion Poplawski <orion@cora.nwra.com> - 2.11.0-1
- Update to 2.11.0

* Mon Sep 08 2014 Rex Dieter <rdieter@fedoraproject.org> 2.10.1-4
- hdfview: update mime scriptlet, fix icon scriptlet

* Sat Aug 16 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.10.1-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_22_Mass_Rebuild

* Tue Jul 15 2014 Clément David <c.david86@gmail.com> - 2.10.1-2
- rebuilt

* Thu Jul 03 2014 Clément David <c.david86@gmail.com> - 2.10.1-1
- Update to jhdf5 1.10.1

* Tue Jun 10 2014 Orion Poplawski <orion@cora.nwra.com> - 2.10-3
- Rebuild for hdf 1.8.13

* Sun Jun 08 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.10-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Fri Feb 28 2014 Clément David <c.david86@gmail.com> - 2.10-1
- Update version
- Change R:java to R:java-headless (Bug 1068283).

* Fri Dec 27 2013 Orion Poplawski <orion@cora.nwra.com> - 2.9-4
- Rebuild for hdf5 1.8.12

* Sat Aug 03 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.9-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild

* Thu May 16 2013 Orion Poplawski <orion@cora.nwra.com> - 2.9-2
- Rebuild for hdf5 1.8.11

* Thu Jan 24 2013 Clément David <c.david86@gmail.com> - 2.9-1
- Update to 2.9
- Upgrade to the Java packaging draft (JNI jar/so location)

* Fri Jan 18 2013 Adam Tkac <atkac redhat com> - 2.8-10
- rebuild due to "jpeg8-ABI" feature drop

* Wed Dec 19 2012 Stanislav Ochotnicky <sochotnicky@redhat.com> - 2.8-9
- revbump after jnidir change

* Mon Dec 03 2012 Orion Poplawski <orion@cora.nwra.com> - 2.8-8
- Rebuild for hdf5 1.8.10
- Add BR libjpeg-devel

* Thu Jul 19 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.8-7
- Rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild

* Tue May 15 2012 Orion Poplawski <orion@cora.nwra.com> - 2.8-6
- Rebuild with hdf5 1.8.9

* Mon Feb 13 2012 Clément David <davidcl@fedoraproject.org> - 2.8-5
- bump version to depends on latest hdf5

* Tue Jan 31 2012 Clément David <davidcl@fedoraproject.org> - 2.8-4
- fix hdfview CLASSPATH

* Mon Jan 30 2012 Clément David <davidcl@fedoraproject.org> - 2.8-3
- split jhdfobj as an object oriented API of jhdf and jhdf5.

* Fri Jan 27 2012 Clément David <davidcl@fedoraproject.org> - 2.8-2
- use %%{_hdf5_version} for hdfview
- use same jhdf and jhdf5 versions for hdfview

* Wed Jan 25 2012 Clément David <davidcl@fedoraproject.org> - 2.8-1
- update to version 2.8

* Wed Jan 25 2012 Clément David <davidcl@fedoraproject.org> - 2.7-9
- move jars to more standard locations

* Fri Jan 13 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.7-8
- Rebuilt for https://fedoraproject.org/wiki/Fedora_17_Mass_Rebuild

* Tue Nov 22 2011 Orion Poplawski <orion@cora.nwra.com> - 2.7-7
- use %%{_hdf5_version}

* Thu Nov 17 2011 Clément David <c.david86@gmail.com> - 2.7-6
- use %%{hdf5ver} to avoid runtime crash

* Thu Nov 03 2011 Clément David <c.david86@gmail.com> - 2.7-5
- rebuilt
* Thu Nov  3 2011 Clément David <c.david86@gmail.com> - 2.7-4
- remove rpm-build BuildRequire

* Tue Oct 25 2011 Clément David <c.david86@gmail.com> - 2.7-3
- Fix executable permissions
- pass rpmlint

* Tue Aug 16 2011 Clément David <c.david86@gmail.com> - 2.7-2
- Update mime types to x-hdf and x-hdf5

* Tue Aug 16 2011 Clément David <c.david86@gmail.com> - 2.7-1
- Initial packaging

